﻿using fgxavi.Common.Data.Translators;
using fgxavi.Gupcat.Data.Contracts;
using fgxavi.Gupcat.Data.Entities;

namespace fgxavi.Gupcat.Data.Translators
{
    public class PolymorphismLambdaTranslator : ITranslator
    {
        public TResult Translate<T, TResult>(T source)
            where T : class
            where TResult : class
        {
            return Translate((dynamic)source);
        }

        #region PersonaFisica
        //private PersonaFisica Translate(PersonaFisicaDTO source)
        //{
        //    return new PersonaFisica()
        //    {
        //        IdentitatId = source.IdentitatId,
        //        Nom = source.Nom,
        //        Cognom1 = source.Cognom1,
        //        Cognom2 = source.Cognom2,
        //        Comentaris = source.Comentaris,
        //    };
        //}
        //private PersonaFisicaDTO Translate(PersonaFisica source)
        //{
        //    return new PersonaFisicaDTO()
        //    {
        //        IdentitatId = source.IdentitatId,
        //        Nom = source.Nom,
        //        Cognom1 = source.Cognom1,
        //        Cognom2 = source.Cognom2,
        //        Comentaris = source.Comentaris,
        //    };
        //}
        #endregion

        #region TIP
        private TIP Translate(TIPDTO source)
        {
            return new TIP()
            {
                TIPId = source.TIPId,
                Nombre = source.Nombre,
                Tipus = source.Tipus,
                IdentitatId = source.IdentitatId
            };
        }
        private TIPDTO Translate(TIP source)
        {
            return new TIPDTO()
            {
                TIPId = source.TIPId,
                Nombre = source.Nombre,
                Tipus = source.Tipus,
                IdentitatId = source.IdentitatId
            };
        }
        #endregion

        #region PersonaJuridica
        //private PersonaJuridica Translate(PersonaJuridicaDTO source)
        //{
        //    return new PersonaJuridica()
        //    {
        //        IdentitatId = source.IdentitatId,
        //        Nom = source.Nom,
        //        Comentaris = source.Comentaris,
        //    };
        //}
        //private PersonaJuridicaDTO Translate(PersonaJuridica source)
        //{
        //    return new PersonaJuridicaDTO()
        //    {
        //        IdentitatId = source.IdentitatId,
        //        Nom = source.Nom,
        //        Comentaris = source.Comentaris,
        //    };
        //}
        #endregion

    }
}
