﻿using System.Web;
using System.Web.Optimization;

namespace fgxavi.Gupcat.Presentation.Web
{
    public class BundleConfig
    {
        // Para obtener más información sobre las uniones, consulte http://go.microsoft.com/fwlink/?LinkId=301862
        public static void RegisterBundles(BundleCollection bundles)
        {
            bundles.Add(new ScriptBundle("~/bundles/jquery").Include(
                "~/Scripts/jquery-{version}.js",
                "~/Scripts/jquery-ui-{version}.js"));

            bundles.Add(new ScriptBundle("~/bundles/jqueryval").Include(
                "~/Scripts/jquery.validate*"));

            bundles.Add(new ScriptBundle("~/bundles/datajs").Include(
                "~/Scripts/datajs-{version}.js"));

            bundles.Add(new ScriptBundle("~/bundles/knockout").Include(
                //    "~/Scripts/knockout-{version}.js",
                //    "~/Scripts/knockout.validation.js"));
                "~/Scripts/knockout-{version}.debug.js",
                "~/Scripts/knockout.validation.js",
                "~/Scripts/knockout.validation.ca-ES.js"));

            bundles.Add(new ScriptBundle("~/bundles/knockout").Include(
                "~/Scripts/knockout-{version}.js"));

            bundles.Add(new ScriptBundle("~/bundles/odata").Include(
                "~/Scripts/odata-query-builder.js"));

            bundles.Add(new ScriptBundle("~/bundles/fgxavi").Include(
                "~/Scripts/fgxavi*"));

            // Utilice la versión de desarrollo de Modernizr para desarrollar y obtener información sobre los formularios. De este modo, estará
            // preparado para la producción y podrá utilizar la herramienta de compilación disponible en http://modernizr.com para seleccionar solo las pruebas que necesite.
            bundles.Add(new ScriptBundle("~/bundles/modernizr").Include(
                "~/Scripts/modernizr-*"));

            bundles.Add(new ScriptBundle("~/bundles/bootstrap").Include(
                "~/Scripts/bootstrap.js",
                "~/Scripts/respond.js"));

            bundles.Add(new StyleBundle("~/Content/css").Include(
                "~/Content/bootstrap.css",
                "~/Scripts/sb-admin.css",
                "~/Content/site.css"));
        }
    }
}
