﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;
using System.Web.Mvc;
using System.Web.Optimization;
using System.Web.Routing;

namespace fgxavi.Gupcat.Presentation.Web
{
    public class WebApiApplication : System.Web.HttpApplication
    {
        protected void Application_Start()
        {
            // Carrega les dependències del projecte al UnityContainer.
            UnityConfig.RegisterComponents();
            // Web API configuration and services
            GlobalConfiguration.Configure(WebApiConfig.Register);

            // Habilitar les referències circulars dels models:
            // http://www.asp.net/web-api/overview/formats-and-model-binding/json-and-xml-serialization#handling_circular_object_references

            // Afegir validació de models als control·ladors Web Api:
            // http://www.asp.net/web-api/overview/formats-and-model-binding/model-validation-in-aspnet-web-api

            AreaRegistration.RegisterAllAreas();
            //GlobalConfiguration.Configure(WebApiConfig.Register);
            FilterConfig.RegisterGlobalFilters(GlobalFilters.Filters);
            RouteConfig.RegisterRoutes(RouteTable.Routes);
            BundleConfig.RegisterBundles(BundleTable.Bundles);
        }
    }
}
